/**
 * @file Event.h
 * @brief CxgǗ
 * @author Naoki Okayama
 * @date 2017/06/28
 */

#ifndef __EVENT_H__
#define __EVENT_H__

class Controller;

#define E_CHANGE_POSITION ((unsigned long)0x00000001)
#define E_STOP ((unsigned long)0x00000002)
// #define E_REACH_POSITION ((unsigned long)0x00000004)

 // [U[ZTCxg
#define E_CHANGE_DISTANCE ((unsigned long)0x00000008)
// #define E_REACH_DISTANCE  ((unsigned long)0x00000010)

// J[ZTCxg
#define E_CHANGE_COLOR          ((unsigned long)0x00000020)

// MQTTʐMCxg
#define E_RECEIVE_DEAL          ((unsigned long)0x00000040)
#define E_RECEIVE_SENSE_OK      ((unsigned long)0x00000080)
#define E_RECEIVE_SENSE_NG      ((unsigned long)0x00000100)
#define E_RECEIVE_SENSE_TIMEOUT ((unsigned long)0x00000200)
#define E_RECEIVE_JUDGE_ACK     ((unsigned long)0x00000400)
#define E_RECEIVE_JUDGE_NACK    ((unsigned long)0x00000800)

// PhyXCb`Cxg
#define E_USR1_ON               ((unsigned long)0x00001000)
#define E_USR1_OFF              ((unsigned long)0x00002000)
#define E_BTN1_ON               ((unsigned long)0x00004000)
#define E_BTN1_OFF              ((unsigned long)0x00008000)
#define E_USR2_ON               ((unsigned long)0x00010000)
#define E_USR2_OFF              ((unsigned long)0x00020000)
#define E_BTN2_ON               ((unsigned long)0x00040000)
#define E_BTN2_OFF              ((unsigned long)0x00080000)

class Event{
public:
  Event(Controller *controller);
  void updateEvent();
  unsigned long getEvent();

 private:
  unsigned long event;
  Controller *controller;
};

#endif
