#ifndef __C_SENSOR_COLOR_H__

/* *** 2重イングルード禁止 *** */
#define __C_SENSOR_COLOR_H__

/* *** ファイルインクルード *** */
#include "CommonDefine.h"

/* *** 定数定義 *** */


/* *** 共通定義 *** */
#define LOW_THRES_RAW  (200)     // RAW値の下限閾値


/* *** 前方宣言 *** */

class CSensorColor {
    /* Variables */
    public:
    private:
        int m_fd;   // ファイル記述子

    /* Functions */
    public:
        CSensorColor(unsigned char ucAddr);
        ~CSensorColor();
        /* *** APIs *** */
        int initDevice(void);
        int getRawValue(int* psiValRed, int* psiValGreen, int* psiValBlue, int* psiValWhite);
        enColor_t getColor(void);
#ifdef _DEBUG

#endif /* _DEBUG */
    private:
        int siWriteRegWord(unsigned char ucAddr, unsigned short uiWriteData);
        int siReadRegWord(unsigned char ucAddr, unsigned short* puiReadData);

};


#endif /* __C_SENSOR_COLOR_H__ */
